OLD-ANALYZE(8)

NAME
old-analyze, analyze - postmortem system crash analyzer

SYNOPSIS
/usr/old/analyze [ -dfmvD ] [ -s swapfile ] corefile [ system ]

DESCRIPTION
analyze is the post-mortem analyzer for the state of the paging system. In order to use analyze you must arrange to get a image of the memory (and possibly the paging area) of the system after it crashes (see panic(8S)).

The analyze program reads the relevant system data structures from the core image file and indexing information from /vmunix (or the specified file) to determine the state of the paging subsystem at the point of crash. It looks at each process in the system, and the resources each is using in an attempt to determine inconsistencies in the paging system state. Normally, the output consists of a sequence of lines showing each active process, its state (whether swapped in or not), its p0br, and the number and location of its page table pages. Any pages which are locked while raw I/O is in progress, or which are locked because they are intransit are also printed. (Intransit text pages often diagnose as duplicated; you will have to weed these out by hand.)

The program checks that any pages in core which are marked as not modified are, in fact, identical to the swap space copies. It also checks for non-overlap of the swap space, and that the core map entries correspond to the page tables. The state of the free list is also checked.

Options to analyze:

-d  Print the (sorted) paging area usage.

-f  Dump the free list.

-m  Dump the entire coremap state.

-v  (Long unused.) Use a hugely verbose output format.

-D  Print the diskmap for each process.

In general, the output from this program can be confused by processes which were forking, swapping, or exiting or happened to be in unusual states when the crash occurred. You should examine the flags fields of relevant processes in the output of a pstat(8) to weed out such processes.

It is possible to look at the core dump with adb(1) if you do

    adb -k /vmunix /vmcore

FILES
/vmunix
    default system namelist

SEE ALSO
adb(1), ps(1), panic(8S), pstat(8)

DIAGNOSTICS
Various diagnostics about overlaps in swap mappings, missing swap mappings, page table entries inconsistent with the core map, incore pages which are marked clean but differ from disk-image copies, pages which are locked or intransit, and inconsistencies in the free list.

It would be nice if this program analyzed the system in general, rather than just the paging system in particular.